diff --git a/tests/manual/quickcontrols/testbench/ApplicationWindow.qml b/tests/manual/quickcontrols/testbench/ApplicationWindow.qml
index 57baed7127..69c21474af 100644
--- a/tests/manual/quickcontrols/testbench/ApplicationWindow.qml
+++ b/tests/manual/quickcontrols/testbench/ApplicationWindow.qml
@@ -1,6 +1,7 @@
 // Copyright (C) 2020 The Qt Company Ltd.
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 ApplicationWindow {}
diff --git a/tests/manual/quickcontrols/testbench/ColorEditor.qml b/tests/manual/quickcontrols/testbench/ColorEditor.qml
index 4d2ab5ad86..4ac875e713 100644
--- a/tests/manual/quickcontrols/testbench/ColorEditor.qml
+++ b/tests/manual/quickcontrols/testbench/ColorEditor.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 import QtQuick.Layouts
 
diff --git a/tests/manual/quickcontrols/testbench/ContentPane.qml b/tests/manual/quickcontrols/testbench/ContentPane.qml
index a42edbdb81..720e65c5a5 100644
--- a/tests/manual/quickcontrols/testbench/ContentPane.qml
+++ b/tests/manual/quickcontrols/testbench/ContentPane.qml
@@ -1,6 +1,7 @@
 // Copyright (C) 2020 The Qt Company Ltd.
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 Pane {}
diff --git a/tests/manual/quickcontrols/testbench/Dialog.qml b/tests/manual/quickcontrols/testbench/Dialog.qml
index f909386c86..a4ef526000 100644
--- a/tests/manual/quickcontrols/testbench/Dialog.qml
+++ b/tests/manual/quickcontrols/testbench/Dialog.qml
@@ -1,6 +1,7 @@
 // Copyright (C) 2020 The Qt Company Ltd.
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 Dialog {}
diff --git a/tests/manual/quickcontrols/testbench/ExampleContainer.qml b/tests/manual/quickcontrols/testbench/ExampleContainer.qml
index 478012c884..4049e60b33 100644
--- a/tests/manual/quickcontrols/testbench/ExampleContainer.qml
+++ b/tests/manual/quickcontrols/testbench/ExampleContainer.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 import QtQuick.Layouts
 
diff --git a/tests/manual/quickcontrols/testbench/Menu.qml b/tests/manual/quickcontrols/testbench/Menu.qml
index 8f39739aaa..b027ee0207 100644
--- a/tests/manual/quickcontrols/testbench/Menu.qml
+++ b/tests/manual/quickcontrols/testbench/Menu.qml
@@ -1,6 +1,7 @@
 // Copyright (C) 2020 The Qt Company Ltd.
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 Menu {}
diff --git a/tests/manual/quickcontrols/testbench/SettingsDialog.qml b/tests/manual/quickcontrols/testbench/SettingsDialog.qml
index 545cf6fa83..7565582017 100644
--- a/tests/manual/quickcontrols/testbench/SettingsDialog.qml
+++ b/tests/manual/quickcontrols/testbench/SettingsDialog.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 import QtQuick.Layouts
 
diff --git a/tests/manual/quickcontrols/testbench/ToolBar.qml b/tests/manual/quickcontrols/testbench/ToolBar.qml
index 1d7c503f56..58cdac80e7 100644
--- a/tests/manual/quickcontrols/testbench/ToolBar.qml
+++ b/tests/manual/quickcontrols/testbench/ToolBar.qml
@@ -1,6 +1,7 @@
 // Copyright (C) 2020 The Qt Company Ltd.
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 ToolBar {}
diff --git a/tests/manual/quickcontrols/testbench/controls/BusyIndicator.qml b/tests/manual/quickcontrols/testbench/controls/BusyIndicator.qml
index 1c14c13a00..833b12f280 100644
--- a/tests/manual/quickcontrols/testbench/controls/BusyIndicator.qml
+++ b/tests/manual/quickcontrols/testbench/controls/BusyIndicator.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/Button.qml b/tests/manual/quickcontrols/testbench/controls/Button.qml
index 12f398ccab..7b1d8d7139 100644
--- a/tests/manual/quickcontrols/testbench/controls/Button.qml
+++ b/tests/manual/quickcontrols/testbench/controls/Button.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/CheckBox.qml b/tests/manual/quickcontrols/testbench/controls/CheckBox.qml
index b595e592b2..ec29cf852d 100644
--- a/tests/manual/quickcontrols/testbench/controls/CheckBox.qml
+++ b/tests/manual/quickcontrols/testbench/controls/CheckBox.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/CheckDelegate.qml b/tests/manual/quickcontrols/testbench/controls/CheckDelegate.qml
index 4e52566ed0..21be87ec39 100644
--- a/tests/manual/quickcontrols/testbench/controls/CheckDelegate.qml
+++ b/tests/manual/quickcontrols/testbench/controls/CheckDelegate.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/ComboBox.qml b/tests/manual/quickcontrols/testbench/controls/ComboBox.qml
index a1c57db693..95bcea5030 100644
--- a/tests/manual/quickcontrols/testbench/controls/ComboBox.qml
+++ b/tests/manual/quickcontrols/testbench/controls/ComboBox.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/DelayButton.qml b/tests/manual/quickcontrols/testbench/controls/DelayButton.qml
index 8509932a0d..6f66751dad 100644
--- a/tests/manual/quickcontrols/testbench/controls/DelayButton.qml
+++ b/tests/manual/quickcontrols/testbench/controls/DelayButton.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/Dial.qml b/tests/manual/quickcontrols/testbench/controls/Dial.qml
index ec7f5411e3..86c48ed078 100644
--- a/tests/manual/quickcontrols/testbench/controls/Dial.qml
+++ b/tests/manual/quickcontrols/testbench/controls/Dial.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/Dialog.qml b/tests/manual/quickcontrols/testbench/controls/Dialog.qml
index 259e1742b4..cccf360053 100644
--- a/tests/manual/quickcontrols/testbench/controls/Dialog.qml
+++ b/tests/manual/quickcontrols/testbench/controls/Dialog.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 import QtQuick.Layouts
 
diff --git a/tests/manual/quickcontrols/testbench/controls/Frame.qml b/tests/manual/quickcontrols/testbench/controls/Frame.qml
index 76f90d7d2f..b363b2286d 100644
--- a/tests/manual/quickcontrols/testbench/controls/Frame.qml
+++ b/tests/manual/quickcontrols/testbench/controls/Frame.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/GroupBox.qml b/tests/manual/quickcontrols/testbench/controls/GroupBox.qml
index 44c122a230..407c2cf544 100644
--- a/tests/manual/quickcontrols/testbench/controls/GroupBox.qml
+++ b/tests/manual/quickcontrols/testbench/controls/GroupBox.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/ItemDelegate.qml b/tests/manual/quickcontrols/testbench/controls/ItemDelegate.qml
index 59b8a6460a..5302ae7be7 100644
--- a/tests/manual/quickcontrols/testbench/controls/ItemDelegate.qml
+++ b/tests/manual/quickcontrols/testbench/controls/ItemDelegate.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/Label.qml b/tests/manual/quickcontrols/testbench/controls/Label.qml
index 6632643803..bd155e2ffb 100644
--- a/tests/manual/quickcontrols/testbench/controls/Label.qml
+++ b/tests/manual/quickcontrols/testbench/controls/Label.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/Menu.qml b/tests/manual/quickcontrols/testbench/controls/Menu.qml
index f1948a7399..f075c2cd82 100644
--- a/tests/manual/quickcontrols/testbench/controls/Menu.qml
+++ b/tests/manual/quickcontrols/testbench/controls/Menu.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 import QtQuick.Layouts
 
diff --git a/tests/manual/quickcontrols/testbench/controls/MenuBar.qml b/tests/manual/quickcontrols/testbench/controls/MenuBar.qml
index 0d53cf8cb6..9f13b55760 100644
--- a/tests/manual/quickcontrols/testbench/controls/MenuBar.qml
+++ b/tests/manual/quickcontrols/testbench/controls/MenuBar.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 // TODO
diff --git a/tests/manual/quickcontrols/testbench/controls/Page.qml b/tests/manual/quickcontrols/testbench/controls/Page.qml
index ef3a0dca7d..4b78a3118f 100644
--- a/tests/manual/quickcontrols/testbench/controls/Page.qml
+++ b/tests/manual/quickcontrols/testbench/controls/Page.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/PageIndicator.qml b/tests/manual/quickcontrols/testbench/controls/PageIndicator.qml
index 4b7c0d5a0d..d828702d29 100644
--- a/tests/manual/quickcontrols/testbench/controls/PageIndicator.qml
+++ b/tests/manual/quickcontrols/testbench/controls/PageIndicator.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 import QtQuick.Layouts
 
diff --git a/tests/manual/quickcontrols/testbench/controls/Pane.qml b/tests/manual/quickcontrols/testbench/controls/Pane.qml
index 7af1ae731a..794d46be32 100644
--- a/tests/manual/quickcontrols/testbench/controls/Pane.qml
+++ b/tests/manual/quickcontrols/testbench/controls/Pane.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/ProgressBar.qml b/tests/manual/quickcontrols/testbench/controls/ProgressBar.qml
index 3632effa3e..ecb562d214 100644
--- a/tests/manual/quickcontrols/testbench/controls/ProgressBar.qml
+++ b/tests/manual/quickcontrols/testbench/controls/ProgressBar.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/RadioButton.qml b/tests/manual/quickcontrols/testbench/controls/RadioButton.qml
index feb8d8f195..78d44868dc 100644
--- a/tests/manual/quickcontrols/testbench/controls/RadioButton.qml
+++ b/tests/manual/quickcontrols/testbench/controls/RadioButton.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/RadioDelegate.qml b/tests/manual/quickcontrols/testbench/controls/RadioDelegate.qml
index 65ca8dcbc1..649bfe84c4 100644
--- a/tests/manual/quickcontrols/testbench/controls/RadioDelegate.qml
+++ b/tests/manual/quickcontrols/testbench/controls/RadioDelegate.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/RangeSlider.qml b/tests/manual/quickcontrols/testbench/controls/RangeSlider.qml
index 75bfbd97a4..d382693508 100644
--- a/tests/manual/quickcontrols/testbench/controls/RangeSlider.qml
+++ b/tests/manual/quickcontrols/testbench/controls/RangeSlider.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/RoundButton.qml b/tests/manual/quickcontrols/testbench/controls/RoundButton.qml
index 9e25c8210a..e362096746 100644
--- a/tests/manual/quickcontrols/testbench/controls/RoundButton.qml
+++ b/tests/manual/quickcontrols/testbench/controls/RoundButton.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/ScrollBar.qml b/tests/manual/quickcontrols/testbench/controls/ScrollBar.qml
index d2124a53cb..d21da47df5 100644
--- a/tests/manual/quickcontrols/testbench/controls/ScrollBar.qml
+++ b/tests/manual/quickcontrols/testbench/controls/ScrollBar.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/ScrollIndicator.qml b/tests/manual/quickcontrols/testbench/controls/ScrollIndicator.qml
index f43027ae58..bdac243563 100644
--- a/tests/manual/quickcontrols/testbench/controls/ScrollIndicator.qml
+++ b/tests/manual/quickcontrols/testbench/controls/ScrollIndicator.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/Slider.qml b/tests/manual/quickcontrols/testbench/controls/Slider.qml
index 098621fc73..2ee9519562 100644
--- a/tests/manual/quickcontrols/testbench/controls/Slider.qml
+++ b/tests/manual/quickcontrols/testbench/controls/Slider.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/SpinBox.qml b/tests/manual/quickcontrols/testbench/controls/SpinBox.qml
index b7df6a080e..697e79fe18 100644
--- a/tests/manual/quickcontrols/testbench/controls/SpinBox.qml
+++ b/tests/manual/quickcontrols/testbench/controls/SpinBox.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/SplitView.qml b/tests/manual/quickcontrols/testbench/controls/SplitView.qml
index 7d7a975561..df7392169a 100644
--- a/tests/manual/quickcontrols/testbench/controls/SplitView.qml
+++ b/tests/manual/quickcontrols/testbench/controls/SplitView.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/SwipeDelegate.qml b/tests/manual/quickcontrols/testbench/controls/SwipeDelegate.qml
index df6de6aacd..13723f2f98 100644
--- a/tests/manual/quickcontrols/testbench/controls/SwipeDelegate.qml
+++ b/tests/manual/quickcontrols/testbench/controls/SwipeDelegate.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/Switch.qml b/tests/manual/quickcontrols/testbench/controls/Switch.qml
index db44ed1900..28f3986b69 100644
--- a/tests/manual/quickcontrols/testbench/controls/Switch.qml
+++ b/tests/manual/quickcontrols/testbench/controls/Switch.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/SwitchDelegate.qml b/tests/manual/quickcontrols/testbench/controls/SwitchDelegate.qml
index 686b38f9ad..029ab70380 100644
--- a/tests/manual/quickcontrols/testbench/controls/SwitchDelegate.qml
+++ b/tests/manual/quickcontrols/testbench/controls/SwitchDelegate.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/TabBar.qml b/tests/manual/quickcontrols/testbench/controls/TabBar.qml
index 96ee0896f4..e083ae1b79 100644
--- a/tests/manual/quickcontrols/testbench/controls/TabBar.qml
+++ b/tests/manual/quickcontrols/testbench/controls/TabBar.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 // TODO
diff --git a/tests/manual/quickcontrols/testbench/controls/TextArea.qml b/tests/manual/quickcontrols/testbench/controls/TextArea.qml
index b9c08846e4..bc07974ce3 100644
--- a/tests/manual/quickcontrols/testbench/controls/TextArea.qml
+++ b/tests/manual/quickcontrols/testbench/controls/TextArea.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/TextField.qml b/tests/manual/quickcontrols/testbench/controls/TextField.qml
index 74719dacad..e33bbb1890 100644
--- a/tests/manual/quickcontrols/testbench/controls/TextField.qml
+++ b/tests/manual/quickcontrols/testbench/controls/TextField.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 
 QtObject {
diff --git a/tests/manual/quickcontrols/testbench/controls/ToolBar.qml b/tests/manual/quickcontrols/testbench/controls/ToolBar.qml
index 867556d152..da98e9e34e 100644
--- a/tests/manual/quickcontrols/testbench/controls/ToolBar.qml
+++ b/tests/manual/quickcontrols/testbench/controls/ToolBar.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 import QtQuick.Layouts
 
diff --git a/tests/manual/quickcontrols/testbench/controls/ToolTip.qml b/tests/manual/quickcontrols/testbench/controls/ToolTip.qml
index f6ec986047..a23b55ed23 100644
--- a/tests/manual/quickcontrols/testbench/controls/ToolTip.qml
+++ b/tests/manual/quickcontrols/testbench/controls/ToolTip.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 import QtQuick.Layouts
 
diff --git a/tests/manual/quickcontrols/testbench/controls/Tumbler.qml b/tests/manual/quickcontrols/testbench/controls/Tumbler.qml
index 067d3664b6..b57ec79ac5 100644
--- a/tests/manual/quickcontrols/testbench/controls/Tumbler.qml
+++ b/tests/manual/quickcontrols/testbench/controls/Tumbler.qml
@@ -2,6 +2,7 @@
 // SPDX-License-Identifier: LicenseRef-Qt-Commercial OR GPL-3.0-only
 
 import QtQuick
+import QtQuick.Controls.Material
 import QtQuick.Controls
 import QtQuick.Layouts
 
diff --git a/tests/manual/quickcontrols/testbench/testbench.qml b/tests/manual/quickcontrols/testbench/testbench.qml
index 68975cfd69..7b6aa6cb76 100644
--- a/tests/manual/quickcontrols/testbench/testbench.qml
+++ b/tests/manual/quickcontrols/testbench/testbench.qml
@@ -5,6 +5,7 @@ import QtCore
 import QtQuick
 import QtQuick.Window
 import QtQuick.Layouts
+import QtQuick.Controls.Material
 import QtQuick.Controls
 import Qt.labs.folderlistmodel
 