diff --git a/sources/pyside6/libpysideremoteobjects/pysidecapsulemethod.cpp b/sources/pyside6/libpysideremoteobjects/pysidecapsulemethod.cpp
index aad440daf..5f9d35710 100644
--- a/sources/pyside6/libpysideremoteobjects/pysidecapsulemethod.cpp
+++ b/sources/pyside6/libpysideremoteobjects/pysidecapsulemethod.cpp
@@ -5,6 +5,7 @@
 
 #include <string.h>
 #include <sbkpep.h>
+#include <QDebug>
 
 extern "C"
 {
@@ -158,6 +159,7 @@ static PyObject *CapsuleMethod_descr_get(PyObject *self, PyObject *instance, PyO
 
 bool add_capsule_method_to_type(PyTypeObject *type, PyMethodDef *method, PyObject *capsule)
 {
+    qDebug() << __FUNCTION__ << method->ml_name;
     if (PyType_Ready(type) < 0) {
         PyErr_Print();
         return false;
diff --git a/sources/pyside6/libpysideremoteobjects/pysidedynamicclass.cpp b/sources/pyside6/libpysideremoteobjects/pysidedynamicclass.cpp
index 8f685713c..c95659c36 100644
--- a/sources/pyside6/libpysideremoteobjects/pysidedynamicclass.cpp
+++ b/sources/pyside6/libpysideremoteobjects/pysidedynamicclass.cpp
@@ -8,6 +8,7 @@
 #include "pysidedynamicclass_p.h"
 #include "pysidecapsulemethod_p.h"
 #include "pysiderephandler_p.h"
+#include "pysideutils.h"
 
 #include <basewrapper.h>
 #include <sbkpep.h>
@@ -22,6 +23,7 @@
 
 #include <QtCore/qmetaobject.h>
 #include <QtCore/qvariantlist.h>
+#include <qdebug.h>
 
 #include <QtRemoteObjects/qremoteobjectpendingcall.h>
 #include <QtRemoteObjects/qremoteobjectreplica.h>
@@ -105,6 +107,7 @@ struct SourceDefs
             return nullptr;
         }
         PyObject *self = methodData->self;
+        qDebug() << __FILE__ << __FUNCTION__ << PySide::debugPyObject(self);
         if (PyCapsule_IsValid(methodData->payload, "PropertyCapsule")) {
             // Handle property getter/setter against our hidden properties attribute
             auto *capsule = PyCapsule_GetPointer(methodData->payload, "PropertyCapsule");
@@ -162,6 +165,8 @@ struct SourceDefs
         if (PyCapsule_IsValid(methodData->payload, "MethodCapsule")) {
             auto *capsule = PyCapsule_GetPointer(methodData->payload, "MethodCapsule");
             auto *callData = reinterpret_cast<MethodCapsule *>(capsule);
+            qDebug() << __FUNCTION__ << callData->name
+                     << callData->methodIndex << callData->argumentTypes;
             if (callData->name.startsWith("push") && callData->name.size() > 4) {
                 const auto *metaObject = PySide::retrieveMetaObject(self);
                 // The convention for QtRO is if a property is named "something" and uses
@@ -461,10 +466,13 @@ PyTypeObject *createDynamicClassImpl(QMetaObject *meta)
         if (metaMethod.methodType() == QMetaMethod::MethodType::Signal)
             continue;
         auto name = metaMethod.name();
+        qDebug() << __FUNCTION__ << meta->className() << i << metaMethod.methodSignature();
         method.ml_name = name.constData();
         QList<QMetaType> argumentTypes;
-        for (int j = 0; j < metaMethod.parameterCount(); ++j)
+        for (int j = 0; j < metaMethod.parameterCount(); ++j) {
+            qDebug() << " " << j << metaMethod.parameterMetaType(j).name() << metaMethod.parameterNames().at(j);
             argumentTypes << metaMethod.parameterMetaType(j);
+        }
         MethodCapsule *capsuleData = new MethodCapsule{metaMethod.name(),
                                                        metaMethod.methodIndex(),
                                                        std::move(argumentTypes),
@@ -481,6 +489,7 @@ PyTypeObject *createDynamicClassImpl(QMetaObject *meta)
 
 PyTypeObject *createDynamicClass(QMetaObject *meta, PyObject *properties_capsule)
 {
+    qDebug() << __FUNCTION__ << meta->className();
     bool isSource;
     if (std::strncmp(meta->superClass()->className(), "QObject", 7) == 0) {
         isSource = true;
diff --git a/sources/pyside6/libpysideremoteobjects/pysidedynamicpod.cpp b/sources/pyside6/libpysideremoteobjects/pysidedynamicpod.cpp
index 5dfdb4484..45aa0eb18 100644
--- a/sources/pyside6/libpysideremoteobjects/pysidedynamicpod.cpp
+++ b/sources/pyside6/libpysideremoteobjects/pysidedynamicpod.cpp
@@ -4,6 +4,7 @@
 #include "pysidedynamicpod_p.h"
 #include "pysidecapsulemethod_p.h"
 #include "pysidedynamiccommon_p.h"
+#include "pysideutils.h"
 
 #include <autodecref.h>
 #include <helper.h>
@@ -15,6 +16,7 @@
 #include <pysidestaticstrings.h>
 
 #include <QtCore/qmetaobject.h>
+#include <QDebug>
 
 using namespace Shiboken;
 
@@ -94,8 +96,9 @@ struct PodDefs
         if (!methodData) {
             PyErr_SetString(PyExc_RuntimeError, "Invalid call to dynamic method.  Missing payload.");
             return nullptr;
-        }
+        }        
         PyObject *self = methodData->self;
+        qDebug() << __FILE__ << __FUNCTION__ << PySide::debugPyObject(self);
         if (PyCapsule_IsValid(methodData->payload, "PropertyCapsule")) {
             // Handle property getter/setter against our hidden properties attribute
             auto *capsule = PyCapsule_GetPointer(methodData->payload, "PropertyCapsule");
@@ -177,6 +180,8 @@ static PythonToCppFunc is_Tuple_PythonToCpp_POD_Convertible(PyObject *pyIn)
 PyTypeObject *createPodType(QMetaObject *meta)
 {
     auto qualname = QByteArrayLiteral("DynamicPod.") + meta->className();
+    qDebug() << __FUNCTION__ << meta->className();
+
     PyType_Spec spec = {
         qualname.constData(),
         0,
diff --git a/sources/pyside6/libpysideremoteobjects/pysiderephandler.cpp b/sources/pyside6/libpysideremoteobjects/pysiderephandler.cpp
index 5804add37..861c963db 100644
--- a/sources/pyside6/libpysideremoteobjects/pysiderephandler.cpp
+++ b/sources/pyside6/libpysideremoteobjects/pysiderephandler.cpp
@@ -178,6 +178,8 @@ static int parseArgsToAST(PyObject *args, PySideRepFile *repFile)
     // Wrap contents into a QBuffer
     const auto contents = PySide::pyStringToQString(PyTuple_GetItem(args, 0));
     auto byteArray = contents.toUtf8();
+    qDebug().noquote().nospace() << __FUNCTION__ << ": >>" << byteArray
+                                 << "<<<<<\n";
     QBuffer buffer(&byteArray);
     buffer.open(QIODevice::ReadOnly);
     RepParser repparser(buffer);
@@ -198,7 +200,15 @@ static int parseArgsToAST(PyObject *args, PySideRepFile *repFile)
         return -1;
     }
 
-    repFile->d->ast = repparser.ast();
+    auto ast = repparser.ast();
+    for (auto c : ast.classes) {
+        for (auto s : c.signalsList)
+            qDebug() << "  " <<  __FUNCTION__ << "SIGNAL" << s.name << s.paramsAsString() << s.paramNames();
+        for (auto s : c.slotsList)
+            qDebug() << "  " <<  __FUNCTION__ << "SLOT" << s.name << s.paramsAsString() << s.paramNames();
+    }
+
+    repFile->d->ast = ast;
 
     return 0;
 }
@@ -212,10 +222,15 @@ static const char *repName(QMetaObject *meta)
 static int RepFile_tp_init(PyObject *self, PyObject *args, PyObject * /* kwds */)
 {
     auto *cppSelf = reinterpret_cast<PySideRepFile *>(self);
+    qDebug() << __FUNCTION__ ;
     if (parseArgsToAST(args, cppSelf) < 0)
         return -1;
 
+    qDebug() << __FUNCTION__ << cppSelf->d->ast.pods.size()
+             << cppSelf->d->ast.classes.size();
+
     for (const auto &pod : std::as_const(cppSelf->d->ast.pods)) {
+        qDebug() << "  " << __FUNCTION__ << "pod.name=" << pod.name;
         cppSelf->d->pods << pod.name;
         auto *qobject = new QObject;
         auto *meta = createAndRegisterMetaTypeFromPOD(pod, qobject);
@@ -248,11 +263,13 @@ static int RepFile_tp_init(PyObject *self, PyObject *args, PyObject * /* kwds */
         PyErr_Print();
 
     for (const auto &cls : std::as_const(cppSelf->d->ast.classes)) {
+        qDebug() << "  " << __FUNCTION__ << "cls.name=" << cls.name;
         cppSelf->d->classes << cls.name;
 
         // Create Source type
         {
             auto *qobject = new QObject;
+            qDebug() << "  created" << qobject;
             auto *meta = createAndRegisterSourceFromASTClass(cls, qobject);
             if (!meta) {
                 delete qobject;
@@ -332,6 +349,8 @@ static int RepFile_tp_init(PyObject *self, PyObject *args, PyObject * /* kwds */
         }
     }
 
+    qDebug() << '<' << __FUNCTION__ ;
+
     return 0;
 }
 
@@ -399,6 +418,7 @@ bool instantiateFromDefaultValue(QVariant &variant, const QString &defaultValue)
 
 static QVariantList generateProperties(QMetaObject *meta, const ASTClass &astClass)
 {
+    qDebug() << __FUNCTION__ << meta->className();
     QVariantList properties;
     auto propertyCount = astClass.properties.size();
     properties.reserve(propertyCount);