diff --git a/src/remoteobjects/qremoteobjectnode.cpp b/src/remoteobjects/qremoteobjectnode.cpp
index f1f917a4..e27aed0b 100644
--- a/src/remoteobjects/qremoteobjectnode.cpp
+++ b/src/remoteobjects/qremoteobjectnode.cpp
@@ -17,6 +17,8 @@
 #include "qremoteobjectabstractitemmodelreplica_p.h"
 #include "qremoteobjectabstractitemmodeladapter_p.h"
 #include <QtCore/qabstractitemmodel.h>
+#include <qdebug.h>
+#include <QLibraryInfo>
 #include <memory>
 #include <algorithm>
 
@@ -1079,14 +1081,20 @@ registerDefinition(const ClassData &data)
     auto type = data.type + (data.isSource ? "Source" : "");
     QMetaObjectBuilder builder;
     builder.setSuperClass(data.baseMeta);
+    qDebug() << __FUNCTION__  << type << data.type << "baseMeta=" << data.baseMeta->className();
+    qDebug() << QLibraryInfo::build();
+
 
     builder.addClassInfo(QCLASSINFO_REMOTEOBJECT_TYPE, data.type);
+    qDebug() << __FUNCTION__  << "QCLASSINFO" << QCLASSINFO_REMOTEOBJECT_TYPE << data.type;
     builder.setClassName(type);
 
     auto [enumLookup, enumsToBeAssignedMetaObject] = handleEnums(builder, data.enums, type);
+    qDebug() << __FUNCTION__  << "enums" << enumLookup;
 
     for (const auto &signal : data._signals) {
         auto mmb = builder.addSignal(signal.signature);
+        qDebug() << __FUNCTION__  << "sig" << signal.signature << signal.parameterNames << mmb.index();
         mmb.setParameterNames(signal.parameterNames);
     }
 
@@ -1099,6 +1107,8 @@ registerDefinition(const ClassData &data)
             mmb = builder.addMethod(slot.signature, slot.returnType);
         else
             mmb = builder.addMethod(slot.signature, QByteArrayLiteral("QRemoteObjectPendingCall"));
+        qDebug() << __FUNCTION__  << "slot" << slot.signature << slot.parameterNames
+                 << "void=" << isVoid << "ret=" << slot.returnType << mmb.index();
         mmb.setParameterNames(slot.parameterNames);
     }
 
@@ -1111,10 +1121,14 @@ registerDefinition(const ClassData &data)
             else
                 qDebug() << "No metaType for property" << prop.name << "of type" << prop.typeName;
         }
-        if (prop.signalName.isEmpty())
+        if (prop.signalName.isEmpty()) {
             mpb = builder.addProperty(prop.name, prop.typeName, metaType);
-        else
+            qDebug() << __FUNCTION__  << "prop" << prop.name << prop.typeName << mpb.index();
+        } else {
+            auto idx =   builder.indexOfSignal(prop.signalName);
             mpb = builder.addProperty(prop.name, prop.typeName, metaType, builder.indexOfSignal(prop.signalName));
+            qDebug() << __FUNCTION__  << "prop sig" << idx << prop.name<< prop.typeName <<  prop.signalName << mpb.index();
+        }
         mpb.setWritable(prop.isWritable);
     }
 
@@ -1129,6 +1143,7 @@ registerDefinition(const ClassData &data)
 
 QMetaObject *registerAndTrackDefinition(const ClassData &data, QObject *reference)
 {
+    qDebug() << __FUNCTION__ << data.type << reference;
     auto [meta, newEnums] = registerDefinition(data);
     if (reference) {
         ManagedTypeEntry entry;
@@ -1213,6 +1228,9 @@ QMetaObject *QRemoteObjectMetaObjectManager::addDynamicType(QtROIoDeviceBase *co
     // auto type = classData.type + (classData.isSource ? "Source" : "");
     auto type = classData.type;
 
+
+    qDebug() << __FUNCTION__ << typeString;
+
     quint32 numEnums = 0;
     in >> numEnums;
     classData.enums.reserve(numEnums);
@@ -1249,6 +1267,7 @@ QMetaObject *QRemoteObjectMetaObjectManager::addDynamicType(QtROIoDeviceBase *co
         in >> classSlot.signature;
         in >> classSlot.returnType;
         in >> classSlot.parameterNames;
+        qDebug() <<  "   " << i  << classSlot.signature <<  classSlot.parameterNames;
         classData._slots.append(std::move(classSlot));
     }
 
diff --git a/src/remoteobjects/qremoteobjectrepparser.cpp b/src/remoteobjects/qremoteobjectrepparser.cpp
index a5311c62..19c6b487 100644
--- a/src/remoteobjects/qremoteobjectrepparser.cpp
+++ b/src/remoteobjects/qremoteobjectrepparser.cpp
@@ -97,6 +97,7 @@ static GadgetData podToGadget(const POD &pod)
 
 QMetaObject *createAndRegisterMetaTypeFromPOD(const POD &pod, QObject *reference)
 {
+    qDebug() << __FUNCTION__ << reference;
     auto gadget = podToGadget(pod);
     return registerGadget(reference, gadget, toQBA(pod.name));
 }
@@ -127,6 +128,7 @@ static std::tuple<bool, bool, bool> replicaModifiers(ASTProperty::Modifier modif
 
 static ClassData classToDefinition(const ASTClass &astClass, bool isSource=false)
 {
+    qDebug() << __FUNCTION__ ;
     std::function<std::tuple<bool, bool, bool>(ASTProperty::Modifier)> modifiers = isSource ? sourceModifiers : replicaModifiers;
 
     // This class converts the AST for a Class into a ClassData structure
@@ -153,8 +155,13 @@ static ClassData classToDefinition(const ASTClass &astClass, bool isSource=false
     }
     for (const auto &signal : astClass.signalsList) {
         ClassSignal classSignal;
-        classSignal.signature = toQBA(signal.name) + '(' + toQBA(signal.paramsAsString(ASTFunction::Normalized)) + ')';
+        auto p = signal.paramsAsString(ASTFunction::Normalized);
         classSignal.parameterNames = toByteArrayList(signal.paramNames());
+        qDebug().noquote().nospace() << __FUNCTION__ << ' ' << signal.name << " parStr=\"" << p << '"';
+        qDebug() <<   "signal.paramNames()=" << signal.paramNames() << "->"
+                 <<   classSignal.parameterNames ;
+        classSignal.signature = toQBA(signal.name) + '(' + toQBA(p) + ')';
+
         classData._signals.append(classSignal);
     }
     for (const auto &slot : astClass.slotsList) {
@@ -195,12 +202,14 @@ static ClassData classToDefinition(const ASTClass &astClass, bool isSource=false
 
 QMetaObject *createAndRegisterReplicaFromASTClass(const ASTClass &astClass, QObject *reference)
 {
+    qDebug() << __FUNCTION__ << reference;
     auto classDef = classToDefinition(astClass);
     return registerAndTrackDefinition(classDef, reference);
 }
 
 QMetaObject *createAndRegisterSourceFromASTClass(const ASTClass &astClass, QObject *reference)
 {
+    qDebug() << __FUNCTION__ << reference;
     auto classDef = classToDefinition(astClass, true);
     return registerAndTrackDefinition(classDef, reference);
 }